"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = require("react");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _clsx = _interopRequireDefault(require("clsx"));
var _omit = _interopRequireDefault(require("lodash/omit"));
var _utils = require("nebenan-helpers/lib/utils");
var _data = require("nebenan-helpers/lib/data");
var _jsxRuntime = require("react/jsx-runtime");
class Dots extends _react.PureComponent {
  constructor(props) {
    super(props);
    (0, _utils.bindTo)(this, 'renderItem');
  }
  renderItem(item, key) {
    const className = (0, _clsx.default)({
      'is-active': this.props.active === key
    });
    const {
      onItemClick
    } = this.props;
    let onClick;
    if (typeof onItemClick === 'function') onClick = onItemClick.bind(this, key);
    return /*#__PURE__*/(0, _jsxRuntime.jsx)("li", {
      key,
      className,
      onClick
    });
  }
  render() {
    const className = (0, _clsx.default)('c-dots', this.props.className);
    const cleanProps = (0, _omit.default)(this.props, 'active', 'count', 'onItemClick');
    const items = (0, _data.arrayOf)(this.props.count).map(this.renderItem);
    return /*#__PURE__*/(0, _jsxRuntime.jsx)("ul", {
      ...cleanProps,
      className: className,
      children: items
    });
  }
}
var _default = exports.default = Dots;
module.exports = exports.default;
module.exports.default = exports.default;