"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = require("react");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _clsx = _interopRequireDefault(require("clsx"));
var _utils = require("nebenan-helpers/lib/utils");
var _jsxRuntime = require("react/jsx-runtime");
class ClipboardText extends _react.PureComponent {
  constructor(props) {
    super(props);
    this.handleClick = this.handleClick.bind(this);
  }
  copyToClipboard() {
    if (!document.queryCommandSupported) return false;
    this.select();
    let result;
    try {
      result = document.execCommand('copy');
    } catch (err) {
      result = false;
    }
    return result;
  }
  select() {
    // hack: contentEditable makes iOS selection work
    this.container.setAttribute('contentEditable', true);
    const range = document.createRange();
    range.selectNodeContents(this.container);
    const selection = global.getSelection();
    selection.removeAllRanges();
    selection.addRange(range);
    this.container.setAttribute('contentEditable', false);
  }
  handleClick(event) {
    this.select();
    (0, _utils.invoke)(this.props.onClick, event);
  }
  render() {
    const className = (0, _clsx.default)('c-clipboard_text', this.props.className);
    const ref = el => {
      this.container = el;
    };
    return /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
      ...this.props,
      className: className,
      ref: ref,
      onClick: this.handleClick
    });
  }
}
var _default = exports.default = ClipboardText;
module.exports = exports.default;
module.exports.default = exports.default;