"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = require("react");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _omit = _interopRequireDefault(require("lodash/omit"));
var _clsx = _interopRequireDefault(require("clsx"));
var _nebenanKeymanager = _interopRequireDefault(require("nebenan-keymanager"));
var _nebenanEventproxy = _interopRequireDefault(require("nebenan-eventproxy"));
var _utils = require("nebenan-helpers/lib/utils");
var _jsxRuntime = require("react/jsx-runtime");
class ContextMenu extends _react.PureComponent {
  constructor(props) {
    super(props);
    this.state = {
      isActive: false
    };
    this.container = /*#__PURE__*/(0, _react.createRef)();
    (0, _utils.bindTo)(this, 'handleGlobalClick', 'hide', 'show', 'toggle');
  }
  componentDidMount() {
    if (this.props.defaultState) this.show();
  }
  componentWillUnmount() {
    this.deactivate();
  }
  activate() {
    if (this.isListenerActive) return;
    this.stopListeningToKeys = (0, _nebenanKeymanager.default)('esc', this.hide);
    this.stopListeningToClicks = (0, _nebenanEventproxy.default)('click', this.handleGlobalClick);
    this.isListenerActive = true;
  }
  deactivate() {
    if (!this.isListenerActive) return;
    this.stopListeningToKeys();
    this.stopListeningToClicks();
    this.isListenerActive = false;
  }
  hide() {
    this.deactivate();
    if (this.isActive()) this.setState({
      isActive: false
    }, this.props.onHide);
  }
  show() {
    this.activate();
    if (!this.isActive()) this.setState({
      isActive: true
    }, this.props.onShow);
  }
  toggle() {
    if (this.isActive()) return this.hide();
    this.show();
  }
  isActive() {
    return this.state.isActive;
  }
  handleGlobalClick(event) {
    // click registered before rendering/after unmounting was complete
    if (!this.container.current) return;
    if (!this.container.current.contains(event.target)) this.hide();
  }
  render() {
    const className = (0, _clsx.default)('c-context_menu', this.props.className, {
      'is-active': this.state.isActive
    });
    const cleanProps = (0, _omit.default)(this.props, 'children', 'label', 'defaultState', 'onHide', 'onShow');
    const label = /*#__PURE__*/(0, _jsxRuntime.jsx)("header", {
      className: "c-context_menu-label",
      onClick: this.toggle,
      children: this.props.label
    });
    return /*#__PURE__*/(0, _jsxRuntime.jsxs)("aside", {
      ...cleanProps,
      className: className,
      ref: this.container,
      children: [label, this.props.children]
    });
  }
}
var _default = exports.default = ContextMenu;
module.exports = exports.default;
module.exports.default = exports.default;