"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _propTypes = _interopRequireDefault(require("prop-types"));
var _clsx = _interopRequireDefault(require("clsx"));
var _parseISO = _interopRequireDefault(require("date-fns/parseISO"));
var _format = _interopRequireDefault(require("date-fns/format"));
var _jsxRuntime = require("react/jsx-runtime");
const DateBox = props => {
  const {
    date,
    locale,
    active,
    ...cleanProps
  } = props;
  const className = (0, _clsx.default)('c-date_box ui-iconbox-label', props.className, {
    'is-disabled': !active
  });
  const dateObj = (0, _parseISO.default)(date);
  let options;
  if (locale) options = {
    locale: locale.modules.dateFns
  };
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("span", {
    ...cleanProps,
    className: className,
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("strong", {
      children: dateObj.getDate()
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)("small", {
      children: (0, _format.default)(dateObj, 'MMM', options)
    })]
  });
};
DateBox.defaultProps = {
  active: true
};
var _default = exports.default = DateBox;
module.exports = exports.default;
module.exports.default = exports.default;