"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = require("react");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _clsx = _interopRequireDefault(require("clsx"));
var _jsxRuntime = require("react/jsx-runtime");
class Expandable extends _react.PureComponent {
  constructor(props) {
    super(props);
    this.handleControlClick = this.handleControlClick.bind(this);
    this.state = {
      isActive: props.defaultState
    };
  }
  handleControlClick() {
    this.setState(prevState => ({
      isActive: !prevState.isActive
    }), this.props.onUpdate);
  }
  render() {
    const {
      isActive
    } = this.state;
    const {
      children,
      defaultState,
      control,
      onUpdate,
      ...cleanProps
    } = this.props;
    const className = (0, _clsx.default)('c-expandable', this.props.className, {
      'is-active': isActive
    });
    const content = isActive && /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      className: "c-expandable-content",
      children: children
    });
    return /*#__PURE__*/(0, _jsxRuntime.jsxs)("article", {
      ...cleanProps,
      className: className,
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("aside", {
        className: "c-expandable-control",
        onClick: this.handleControlClick,
        children: control
      }), content]
    });
  }
}
Expandable.defaultProps = {
  defaultState: false
};
var _default = exports.default = Expandable;
module.exports = exports.default;
module.exports.default = exports.default;