"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = require("react");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _clsx = _interopRequireDefault(require("clsx"));
var _omit = _interopRequireDefault(require("lodash/omit"));
var _clamp = _interopRequireDefault(require("lodash/clamp"));
var _nebenanHeartbeat = _interopRequireDefault(require("nebenan-heartbeat"));
var _utils = require("nebenan-helpers/lib/utils");
var _dots = _interopRequireDefault(require("../_dots"));
var _jsxRuntime = require("react/jsx-runtime");
class FadingSlideshow extends _react.PureComponent {
  constructor(props) {
    super(props);
    this.state = {
      activeItemIndex: this.props.defaultItemIndex
    };
    (0, _utils.bindTo)(this, 'setSlide', 'rotate', 'renderItem');
  }
  componentDidMount() {
    this.startAutoRotation();
  }
  componentWillUnmount() {
    if (this.stopAutoRotation) this.stopAutoRotation();
  }
  setSlide(index) {
    if (this.stopAutoRotation) this.stopAutoRotation();
    this.setState((state, props) => {
      const validIndex = (0, _clamp.default)(index, 0, props.items.length - 1);
      return {
        activeItemIndex: validIndex
      };
    }, this.startAutoRotation);
  }
  startAutoRotation() {
    this.stopAutoRotation = (0, _nebenanHeartbeat.default)(this.props.rotationInterval, this.rotate);
  }
  rotate() {
    let index = this.state.activeItemIndex + 1;
    if (index >= this.props.items.length) index = 0;
    this.setSlide(index);
  }
  renderDots() {
    if (this.props.items.length > 1) {
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_dots.default, {
        count: this.props.items.length,
        active: this.state.activeItemIndex,
        onItemClick: this.setSlide
      });
    }
  }
  renderItem(item, index) {
    const className = (0, _clsx.default)('c-fading_slideshow-item', {
      'is-active': this.state.activeItemIndex === index
    });
    return /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
      className: className,
      children: item
    });
  }
  render() {
    const className = (0, _clsx.default)('c-fading_slideshow', this.props.className);
    const {
      children,
      items
    } = this.props;
    const cleanProps = (0, _omit.default)(this.props, 'children', 'items', 'defaultItemIndex', 'rotationInterval');
    const content = _react.Children.map(items, this.renderItem);
    return /*#__PURE__*/(0, _jsxRuntime.jsxs)("article", {
      ...cleanProps,
      className: className,
      children: [content, this.renderDots(), children]
    });
  }
}
FadingSlideshow.defaultProps = {
  defaultItemIndex: 0,
  rotationInterval: 1000 * 15
};
var _default = exports.default = FadingSlideshow;
module.exports = exports.default;
module.exports.default = exports.default;