"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = require("react");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _omit = _interopRequireDefault(require("lodash/omit"));
var _clsx = _interopRequireDefault(require("clsx"));
var _jsxRuntime = require("react/jsx-runtime");
class FilePicker extends _react.PureComponent {
  constructor(props) {
    super(props);
    this.input = /*#__PURE__*/(0, _react.createRef)();
    this.handleChange = this.handleChange.bind(this);
  }
  getInput() {
    return this.input.current;
  }
  handleChange(event) {
    const {
      files
    } = event.target;

    // some browsers trigger change with empty set
    if (this.props.onSelect && files.length) this.props.onSelect(files);
    if (this.props.onChange) this.props.onChange(event);
    this.input.current.value = '';
  }
  render() {
    const className = (0, _clsx.default)('c-file_picker', this.props.className);
    const cleanProps = (0, _omit.default)(this.props, 'onSelect', 'children', 'className');
    return /*#__PURE__*/(0, _jsxRuntime.jsxs)("span", {
      className: className,
      children: [this.props.children, /*#__PURE__*/(0, _jsxRuntime.jsx)("input", {
        ...cleanProps,
        ref: this.input,
        type: "file",
        className: "c-file_picker-input",
        onChange: this.handleChange
      })]
    });
  }
}
var _default = exports.default = FilePicker;
module.exports = exports.default;
module.exports.default = exports.default;