"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.LoadingSpinner = void 0;
var _react = require("react");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _clsx = _interopRequireDefault(require("clsx"));
var _jsxRuntime = require("react/jsx-runtime");
const ANIMATION_DURATION = 400;
class LoadingBar extends _react.PureComponent {
  constructor(props) {
    super(props);
    this.state = this.getDefaultState(props);
    this.reset = this.reset.bind(this);
  }
  componentDidUpdate(prevProps) {
    if (!prevProps.active && this.props.active) this.setActive();else if (this.state.isActive) this.setComplete();
    this.clear();
    this._tid = setTimeout(this.reset, ANIMATION_DURATION);
  }
  componentWillUnmount() {
    this.clear();
  }
  getDefaultState(props) {
    return {
      isActive: props.active,
      isComplete: false
    };
  }
  setActive() {
    this.setState({
      isActive: true,
      isComplete: false
    });
  }
  setComplete() {
    this.setState({
      isComplete: true
    });
  }
  clear() {
    if (this._tid) clearTimeout(this._tid);
  }
  reset(done) {
    this.setState({
      isActive: false,
      isComplete: false
    }, done);
  }
  render() {
    const {
      isActive,
      isComplete
    } = this.state;
    const className = (0, _clsx.default)('c-loading-bar', this.props.className, {
      'is-active': isActive,
      'is-complete': isComplete
    });
    return /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
      className: className,
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)("i", {})
    });
  }
}
LoadingBar.defaultProps = {
  active: false
};
var _default = exports.default = LoadingBar;
const LoadingSpinner = () => /*#__PURE__*/(0, _jsxRuntime.jsx)("aside", {
  className: "c-loading-spinner",
  children: /*#__PURE__*/(0, _jsxRuntime.jsx)("i", {})
});
exports.LoadingSpinner = LoadingSpinner;