"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isItemWidthChanged = exports.getSectionsCount = exports.getItemWidth = exports.getGridPosition = exports.getActiveSection = exports.SWIPE_TRIGGER_DISTANCE = exports.BOUNDARIES_EXCESS = void 0;
var _dom = require("nebenan-helpers/lib/dom");
const BOUNDARIES_EXCESS = exports.BOUNDARIES_EXCESS = 40;
const SWIPE_TRIGGER_DISTANCE = exports.SWIPE_TRIGGER_DISTANCE = 20;
const getItemWidth = (win, sceneWidth, props) => {
  let mediaType = 'Mobile';
  if ((0, _dom.getMedia)(win, _dom.media.mediaM)) mediaType = 'Tablet';
  if ((0, _dom.getMedia)(win, _dom.media.mediaL)) mediaType = 'Desktop';
  return sceneWidth / props[`visible${mediaType}`];
};
exports.getItemWidth = getItemWidth;
const getGridPosition = (position, sceneWidth, direction) => {
  let gridPosition = position - position % sceneWidth;
  if (direction > 0) gridPosition -= sceneWidth;
  return gridPosition;
};
exports.getGridPosition = getGridPosition;
const getSectionsCount = (sceneWidth, listWidth) => Math.ceil(listWidth / sceneWidth) || 1;
exports.getSectionsCount = getSectionsCount;
const getActiveSection = (position, sceneWidth) => Math.ceil(Math.abs(position / sceneWidth));
exports.getActiveSection = getActiveSection;
const isItemWidthChanged = (prevProps, props) => {
  if (prevProps.visibleMobile !== props.visibleMobile) return true;
  if (prevProps.visibleTablet !== props.visibleTablet) return true;
  if (prevProps.visibleDesktop !== props.visibleDesktop) return true;
  return false;
};
exports.isItemWidthChanged = isItemWidthChanged;