"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = require("react");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _clsx = _interopRequireDefault(require("clsx"));
var _omit = _interopRequireDefault(require("lodash/omit"));
var _reactRouter = require("react-router");
var _history = require("nebenan-react-hocs/lib/history");
var _utils = require("nebenan-helpers/lib/utils");
var _routes = require("nebenan-helpers/lib/routes");
var _jsxRuntime = require("react/jsx-runtime");
const defaultGetItem = (index, items) => items[index].text;
class TabBar extends _react.PureComponent {
  constructor(props) {
    super(props);
    this.renderItem = this.renderItem.bind(this);
  }
  handleClick(key) {
    const {
      items,
      history
    } = this.props;
    const {
      href,
      callback
    } = items[key];
    if (href) history.push((0, _routes.stripOriginFromUrl)(href, global.location.origin));
    (0, _utils.invoke)(callback, key);
  }
  renderItem(item, key) {
    const {
      activeIndex,
      getItem,
      items
    } = this.props;
    const renderer = getItem || defaultGetItem;
    const className = (0, _clsx.default)('c-tab_bar-item', {
      'is-active': key === activeIndex
    });
    const onClick = this.handleClick.bind(this, key);
    const props = {
      key,
      className,
      onClick
    };
    return /*#__PURE__*/(0, _jsxRuntime.jsx)("li", {
      ...props,
      children: renderer(key, items)
    });
  }
  render() {
    const className = (0, _clsx.default)('c-tab_bar', this.props.className);
    const cleanProps = (0, _omit.default)(this.props, ...Object.keys(_history.historyPropTypes), 'children', 'action', 'items', 'getItem', 'activeIndex');
    const {
      items,
      action,
      children
    } = this.props;
    let list;
    if (items) list = /*#__PURE__*/(0, _jsxRuntime.jsx)("ul", {
      className: "c-tab_bar-list",
      children: items.map(this.renderItem)
    });
    let actionNode;
    if (action) actionNode = /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
      className: "c-tab_bar-action",
      children: action
    });
    let content;
    if (children) content = /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
      className: "c-tab_bar-content",
      children: children
    });
    return /*#__PURE__*/(0, _jsxRuntime.jsxs)("article", {
      ...cleanProps,
      className: className,
      children: [actionNode, /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
        className: "c-tab_bar-container",
        children: [list, content]
      })]
    });
  }
}
var _default = exports.default = (0, _reactRouter.withRouter)(TabBar);
module.exports = exports.default;
module.exports.default = exports.default;