"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = require("react");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _clsx = _interopRequireDefault(require("clsx"));
var _omit = _interopRequireDefault(require("lodash/omit"));
var _reactRouter = require("react-router");
var _utils = require("nebenan-helpers/lib/utils");
var _routes = require("nebenan-helpers/lib/routes");
var _history = require("nebenan-react-hocs/lib/history");
var _side_scroller = _interopRequireDefault(require("../side_scroller"));
var _jsxRuntime = require("react/jsx-runtime");
const defaultGetItem = (index, items) => items[index].text;
class TabScroller extends _react.PureComponent {
  constructor(props) {
    super(props);
    this.renderItem = this.renderItem.bind(this);
  }
  handleClick(key) {
    const {
      items,
      history
    } = this.props;
    const {
      href,
      callback
    } = items[key];
    if (href) history.push((0, _routes.stripOriginFromUrl)(href, global.location.origin));
    (0, _utils.invoke)(callback, key);
  }
  renderItem(item, key) {
    const {
      activeIndex,
      getItem,
      items
    } = this.props;
    const {
      href,
      callback
    } = items[key];
    const renderer = getItem || defaultGetItem;
    const className = (0, _clsx.default)('c-tab_scroller-item', {
      'is-active': key === activeIndex,
      'is-clickable': Boolean(href || callback)
    });
    const onClick = this.handleClick.bind(this, key);
    const props = {
      key,
      className,
      onClick
    };
    return /*#__PURE__*/(0, _jsxRuntime.jsx)("li", {
      ...props,
      children: renderer(key, items)
    });
  }
  render() {
    const className = (0, _clsx.default)('c-tab_scroller', this.props.className);
    const cleanProps = (0, _omit.default)(this.props, ...Object.keys(_history.historyPropTypes), 'items', 'getItem', 'activeIndex');
    return /*#__PURE__*/(0, _jsxRuntime.jsx)(_side_scroller.default, {
      ...cleanProps,
      className: className,
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)("ul", {
        className: "c-tab_scroller-list",
        children: this.props.items.map(this.renderItem)
      })
    });
  }
}
var _default = exports.default = (0, _reactRouter.withRouter)(TabScroller);
module.exports = exports.default;
module.exports.default = exports.default;