"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = require("react");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _clsx = _interopRequireDefault(require("clsx"));
var _utils = require("nebenan-helpers/lib/utils");
var _proxy_ref = _interopRequireWildcard(require("nebenan-react-hocs/lib/proxy_ref"));
var _autocomplete = _interopRequireDefault(require("../autocomplete"));
var _jsxRuntime = require("react/jsx-runtime");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
class TagInput extends _react.PureComponent {
  constructor(props) {
    super(props);
    (0, _utils.bindTo)(this, 'getMergedRefFn', 'handleEnterKey', 'handleClick', 'handleSelect', 'handleValidSelect');
  }
  getMergedRefFn() {
    return (0, _proxy_ref.getMergedRef)(this.props.forwardedRef, ref => {
      this.inputRef = ref;
    });
  }
  handleEnterKey(event) {
    event.preventDefault();
    (0, _utils.invoke)(this.props.onEnterKey, event);
    this.handleSelect();
  }
  handleClick(event) {
    event.preventDefault(); // do not reset validation
    this.handleSelect();
  }
  handleSelect() {
    this.inputRef.current.validate().then(this.handleValidSelect);
  }
  handleValidSelect() {
    const value = this.inputRef.current.getValue();
    if (value) (0, _utils.invoke)(this.props.onSelect, value);
  }
  render() {
    const className = (0, _clsx.default)('c-tag_input', this.props.className);
    const {
      forwardedRef,
      errorMessage,
      addMessage,
      ...props
    } = this.props;
    return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_autocomplete.default, {
      ...props,
      className: className,
      ref: this.getMergedRefFn(),
      onEnterKey: this.handleEnterKey,
      onSelect: this.handleSelect,
      error: errorMessage,
      validate: "isShortText",
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
        className: "c-tag_input-add_button",
        onClick: this.handleClick,
        children: addMessage
      }), this.props.children]
    });
  }
}
var _default = exports.default = (0, _proxy_ref.default)(TagInput);
module.exports = exports.default;
module.exports.default = exports.default;