"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = require("react");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _clsx = _interopRequireDefault(require("clsx"));
var _omit = _interopRequireDefault(require("lodash/omit"));
var _data = require("nebenan-helpers/lib/data");
var _utils = require("nebenan-helpers/lib/utils");
var _proxy_ref = _interopRequireDefault(require("nebenan-react-hocs/lib/proxy_ref"));
var _tag_cloud = _interopRequireDefault(require("../tag_cloud"));
var _tag_input = _interopRequireDefault(require("../tag_input"));
var _jsxRuntime = require("react/jsx-runtime");
class TagsPicker extends _react.PureComponent {
  constructor(props) {
    super(props);
    (0, _utils.bindTo)(this, 'handleSelect');
    this.tagInput = /*#__PURE__*/(0, _react.createRef)();
  }
  handleSelect(tag) {
    if (this.itemsHash[tag]) return;
    this.props.onSelect(tag);
    this.tagInput.current.reset();
  }
  render() {
    const className = (0, _clsx.default)('c-tags_picker', this.props.className);
    const cleanProps = (0, _omit.default)(this.props, 'children', 'placeholder', 'options', 'items', 'onSelect');
    const {
      options,
      items,
      placeholder,
      children,
      forwardedRef,
      errorMessage,
      addMessage
    } = this.props;
    this.itemsHash = (0, _data.arrayToHash)(items);
    return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_tag_cloud.default, {
      ...cleanProps,
      ref: forwardedRef,
      items: items,
      className: className,
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_tag_input.default, {
        ref: this.tagInput,
        placeholder: placeholder,
        options: options,
        onSelect: this.handleSelect,
        errorMessage: errorMessage,
        addMessage: addMessage
      }), children]
    });
  }
}
var _default = exports.default = (0, _proxy_ref.default)(TagsPicker);
module.exports = exports.default;
module.exports.default = exports.default;